import { useEffect, useState } from 'react';
const defaultDeps = [];
export function useAsyncMemo(callback, deps = defaultDeps) {
    const [res, update] = useState({
        loading: true,
    });
    useEffect(() => {
        let ok = true;
        if (!res.loading)
            update({ ...res, loading: true });
        callback().then(result => {
            if (!ok)
                return;
            update({
                result,
                loading: false,
            });
        }).catch(error => {
            if (!ok)
                return;
            update({
                error,
                loading: false,
            });
        });
        return () => { ok = false; };
    }, deps);
    return res;
}
export default useAsyncMemo;
